///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 3: 3D Spatial Interactive
// Drawing Helper Functions
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////

float barPosX;
float barPosY_cout,  barPosY_cin;

float barLength = 150;
float barHeight = 20;
  
int colorThemeCout = 0;
int colorThemeCin  = 0;

color colorStrip[]      = {color(180, 155, 255),       //scheme 0
                           color(180, 150, 255, 100),  //scheme 1
                           color(255, 150, 50),        //scheme 2
                           color(255, 150, 50),        //scheme 3
                           color(170),                 //scheme 4
                           color(178, 255, 102),       //scheme 5
                           color(178, 255, 102),       //scheme 6
                           color(200, 200, 0)          //scheme 7         
                          };

color colorBarOutline[] = {color(30, 144, 255,200),    //scheme 0
                           color(180, 155, 255, 100),  //scheme 1
                           color(255, 150, 50, 100),   //scheme 2
                           color(255, 153, 204, 100),  //scheme 3
                           color(255, 255, 255, 100),  //scheme 4
                           color(255, 150, 50, 100),   //scheme 5
                           color(0,   204,  0, 100),   //scheme 6
                           color(200, 200, 0)          //scheme 7
                          };
                          
int colorMode[]          = {HSB, HSB, HSB, HSB, HSB, HSB, HSB, RGB};
int colorMode2[]         = {RGB, HSB, HSB, HSB, RGB, HSB, HSB, RGB};

String leftBarLabels[]  = {"RGB: Year, Month, Day", "2006", "0 minute", 
                           "1st Day of the Month", "00 hour", "Januaries", 
                           "00:00", "n/a"};
                        
String rightBarLabels[] = {"", "2013", "59 minutes", "Last Day", 
                         "24 hour", "Decembers", "24:00", ""};

int barSlices = 100;

void colorBarFill(int i, int colorTheme)
{
  colorMode(colorMode[colorTheme]);
  switch(colorTheme)
  {
    case 0:
      fill( red(colorStrip[colorTheme]), green(colorStrip[colorTheme]), 
           blue(colorStrip[colorTheme]) * i / barSlices);
      break;
      
    case 1:
      fill(  red(colorStrip[colorTheme]) * i / barSlices, 
           green(colorStrip[colorTheme]),
            blue(colorStrip[colorTheme]) * i / barSlices);
      break;
      
    case 2:
      fill(       hue(colorStrip[colorTheme]) * i / barSlices, 
           saturation(colorStrip[colorTheme]),
           brightness(colorStrip[colorTheme]) * i / barSlices);
      break;
      
    case 3:
      fill(  red(colorStrip[colorTheme]) * i / barSlices, 
           green(colorStrip[colorTheme]),
            blue(colorStrip[colorTheme]) * 4);
      break;
      
    case 4:
      fill(  red(colorStrip[colorTheme]) * i / barSlices);
      break;
      
    case 5:
      fill(         hue(colorStrip[colorTheme]) - 30, 
             saturation(colorStrip[colorTheme]) + 70,
             brightness(colorStrip[colorTheme]) * i / barSlices);
      break;
      
    case 6:
      fill(         hue(colorStrip[colorTheme]), 
             saturation(colorStrip[colorTheme]) + 30,
             brightness(colorStrip[colorTheme]) * i / barSlices);
      break;
      
    case 7:
      fill( red( (colorStrip[colorTheme]) * i / 12),  //candy
            green( (colorStrip[colorTheme]) * i / 31),
            blue( (colorStrip[colorTheme]) * i / 8));
      break;
      
    default:
      break;
  }
}

void makeColorBar()
{
  barPosX = p5Margin;
  barPosY_cout = p5Margin + 5 * p5Distance; 
  barPosY_cin  = p5Margin + 6 * p5Distance + barHeight;
  
  noStroke();
  for(int i = 0; i < barSlices; i+=1)
  {
    colorMode(colorMode[colorThemeCout]);
    colorBarFill(i, colorThemeCout);
    rect(barPosX + (i * (barLength / barSlices)), barPosY_cout, 
         barLength / barSlices, barHeight);
    
    colorMode(colorMode[colorThemeCin]);
    colorBarFill(i, colorThemeCin);
    rect(barPosX + (i * (barLength / barSlices)), barPosY_cin, 
         barLength / barSlices, barHeight);
  }
  
  //COUT
  noFill();
  colorMode(RGB);
  strokeWeight(1);
  stroke(colorBarOutline[colorThemeCout]);
  rect(barPosX, barPosY_cout, barLength, barHeight);
  
  textAlign(LEFT,LEFT);
  text(leftBarLabels[colorThemeCout], 
  barPosX, 
  barPosY_cout + barHeight + 15);
  
  textAlign(LEFT,LEFT);
  text(rightBarLabels[colorThemeCout], 
  barPosX + barLength - 30, 
  barPosY_cout + barHeight + 15);
  
  //CIN
  stroke(colorBarOutline[colorThemeCin]);
  rect(barPosX, barPosY_cin, barLength, barHeight);
  
  textAlign(LEFT,LEFT);
  text(leftBarLabels[colorThemeCin], 
  barPosX, 
  barPosY_cin + barHeight + 15);
  
  textAlign(LEFT,LEFT);
  text(rightBarLabels[colorThemeCin], 
  barPosX + barLength - 30, 
  barPosY_cin + barHeight + 15);
}
//                 j        k      m       n       p
//format: 0:dewey, 1:month, 2:day, 3:year, 4:hour, 5 :min - cout
//                 6:month, 7:day, 8:year, 9:hour, 10:min - cin
void pointColor(int i, int monthLength, int colorTheme, int j, int k, int m, int n, int p)
{
  float alpha = transparency + transparency * noise(i * millis() );

  if(glitter == 0)
    alpha = 255.0;
    
  colorMode(colorMode2[colorTheme]);
  strokeWeight(pointSize);
  
  switch(colorTheme)
  {
    case 0: 
        stroke(  red(colorStrip[colorTheme]) * j / 12, 
               green(colorStrip[colorTheme]) * k / monthLength,
                blue(colorStrip[colorTheme]) * m / 8,
                alpha);
      break;
      
    case 1:  //by year: 2006 = green, 2013 = pink
      stroke(  red(colorStrip[colorTheme]) * (m - 2006) / 8, 
             green(colorStrip[colorTheme]),
              blue(colorStrip[colorTheme]) * (m - 2006) / 8,
              alpha);
      break;
      
    case 2: //by the minute
      stroke(       hue(colorStrip[colorTheme]) * p / 60, 
             saturation(colorStrip[colorTheme]),
             brightness(colorStrip[colorTheme]) * p / 60,
             alpha);
      break;
    
    case 3:  //by day 
      stroke(  red(colorStrip[colorTheme]) * k / monthLength, 
             green(colorStrip[colorTheme]),
              blue(colorStrip[colorTheme]) * 4,
              alpha);
      break;
    
    case 4:  //by the hour
      stroke(  red(colorStrip[colorTheme]) * n / 24, alpha);
      break;
    
    case 5: //by month
      stroke(         hue(colorStrip[colorTheme]) - 30, 
               saturation(colorStrip[colorTheme]) + 70,
               brightness(colorStrip[colorTheme]) * j / 12,
               alpha);
      break;
    
    case 6: //by time
      stroke(         hue(colorStrip[colorTheme]), 
               saturation(colorStrip[colorTheme]) + 30,
               brightness(colorStrip[colorTheme]) * (n + p) / (24 + 60),
               alpha);
      break;
    
    case 7:    //Candy
      stroke(  red( (colorStrip[colorTheme]) * i / 12),  
               green( (colorStrip[colorTheme]) * j / 31),
               blue( (colorStrip[colorTheme]) * k / 8),
               alpha);
      break;
    
    default:
      break;
  }

}



