///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 3: 3D Spatial Interactive
// Control P5 Functions
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////

DropdownList dropDownMenu;
DropdownList coutColorMenu, cinColorMenu;
DropdownList dropdown;

int dataShape = 0;
String[] dataShapes  = {"Point Cloud", "Point Star"};
String[] colorThemes = {"Theme 1", "Theme 2", "Theme 3",
                        "Theme 4", "Theme 5", "Theme 6",
                        "Theme 7", "Theme 8"};
                        
void drawGUI()
{
  currCameraMatrix = new PMatrix3D(g3.camera);
  camera();
  controlP5.draw();
  g3.camera = currCameraMatrix;
  
  if(dropDownMenu.isOpen() || coutColorMenu.isOpen() || cinColorMenu.isOpen())
  {
    controlP5.getController("Transparency").hide();
    controlP5.getController("Point Size").hide();
  }
  else
  {
    controlP5.getController("Transparency").show();
    controlP5.getController("Point Size").show();
  }
}

void setupGUI()
{
  controlP5 = new ControlP5(this);
  controlP5.setFont(myFont1);
  //controlP5.setControlFont(myFont2);
  
  //Make DropDown Lists
  dropDownMenu = controlP5.addDropdownList("dropDownMenu")
                 .setPosition(p5Margin, height * 0.05);
  customize(dropDownMenu, "Data Shapes", dataShapes);
  
  //For Checkouts
  coutColorMenu = controlP5.addDropdownList("coutColorMenu")
                  .setPosition(p5Margin * 4, height * 0.05);
  customize(coutColorMenu, "Checkout Themes", colorThemes);
  
  //For Checkins
  cinColorMenu = controlP5.addDropdownList("cinColorMenu")
                  .setPosition(p5Margin * 8, height * 0.05);
  customize(cinColorMenu, "Check-in Themes", colorThemes);
   
  //SLIDERS 
  controlP5.addSlider("Transparency")
    .setMin(1)
    .setMax(100)
    .setValue(50)
    .setPosition(p5Margin, p5Margin + p5Distance)
    .setWidth(buttonWidth)
    .setHeight(buttonHeight);
    
  controlP5.addSlider("Point Size")
    .setMin(1)
    .setMax(100)
    .setValue(14)
    .setPosition(p5Margin, p5Margin + 2 * p5Distance)
    .setWidth(buttonWidth)
    .setHeight(buttonHeight); 

  controlP5.addSlider("Group Appearance")
    .setMin(1)
    .setMax(MAX_GROUP)
    .setValue(MAX_GROUP)
    .setNumberOfTickMarks(MAX_GROUP)
    .setPosition(p5Margin, p5Margin + 3 * p5Distance)
    .setWidth(buttonWidth)
    .setHeight(buttonHeight);   
  controlP5.setAutoDraw(false);

  controlP5.addSlider("Glitter")
    .setMin(0)
    .setMax(1)
    .setValue(1)
    .setNumberOfTickMarks(2)
    .setPosition(p5Margin, p5Margin + 4 * p5Distance)
    .setWidth(buttonWidth)
    .setHeight(buttonHeight);   
  controlP5.setAutoDraw(false);
}

//This must check for both event types: isGroup and isController
void controlEvent(ControlEvent event)
{
  //the event type isGroup is used for the dropDownLists
  if (event.isGroup()) 
  {
    if (event.group().name() == "dropDownMenu")
    { 
      dataShape = int(event.group().value());
      dropDownMenu.captionLabel().set("Data Shapes");
    }
    if(event.group().name() == "coutColorMenu")
    {
      colorThemeCout = int(event.group().value());
      coutColorMenu.captionLabel().set("Checkout Themes");      
    }
    if(event.group().name() == "cinColorMenu")
    {
      colorThemeCin = int(event.group().value());
      cinColorMenu.captionLabel().set("Check-in Themes");      
    }
  } 
  else if(event.isController()) 
  {
    if(event.controller().name() == "Point Size")
      pointSize = int(event.controller().value()); 
    
    if(event.controller().name() == "Transparency")
      transparency = int(event.controller().value());
    
    if(event.controller().name() == "Glitter")
      glitter = int(event.controller().value());
    
    if(event.controller().name() == "Group Appearance")
    {
      groupAppearance = int(event.controller().value());
      counterGroup = groupAppearance;
      cout_pts.clear();
      cin_pts.clear();
      
      cout_pts = new IntList();
      cin_pts  = new IntList();
      chooseRandomPoints();
    }
    
    print("Control Event From: " + event.controller().name());
    println(", value: " + event.controller().value());
  }
  
}

void customize(DropdownList menu, String menuLabel, String[] items)
{
  menu.setBackgroundColor(color(190));
  menu.setItemHeight(20);
  menu.setBarHeight(15);
  menu.captionLabel().set(menuLabel);
  menu.captionLabel().style().marginTop  = 3;
  menu.captionLabel().style().marginLeft = 3;
  menu.valueLabel().style().marginTop    = 3;
  
  println("LEN: " + items.length);
  for(int i = 0; i < items.length; i++)
    menu.addItem(items[i], i);
  
  //menu.scroll(1);
  //menu.setScrollbarVisible(true);
  //menu.showScrollbar();
  
  menu.setColorBackground(color(60));
  menu.setColorActive(color(255, 128));
}























