///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 3: 3D Spatial Interactive
// Draw Function and Helpers
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////
int maxDays = 1792;
IntList daysPassed;
IntList cout_pts;
IntList cin_pts;

void draw()
{
  colorMode(RGB, 255, 255, 255);
  background(0, 0, 0);
  lights();
  
  if(drawBoundingBox)
    DrawBoundingBox();
  
  switch(dataShape)
  {
    case 0:  
      DrawPointSwirl();
      break;
       
    case 1:
      DrawPointStar(); 
      break;
    

      
    default:
      //DrawPointSwirl();
      break;
  }
    
  //Deactivate PeasyCam Rotations when Sliders are Active
  if(controlP5.window(this).isMouseOver())
    cam.setActive(false);
  else
    cam.setActive(true);
  
  drawGUI();
  setHUD();
  
  if(saveMovie)
    SaveMovie();
    
  makeColorBar();
}

void keyPressed()
{
  if(key == ' ')
    saveFrame("images/####.jpg");
}

void DrawBoundingBox()
{
  noFill();
  strokeWeight(1);
  stroke(255, 64);
  
  line(-500 * xTweak, 0, 0, 
        500 * xTweak, 0, 0);
          
  line(0, -10*60 * yTweak, 0, 
       0,  10*60 * yTweak, 0);
         
  line(0, 0, -6 * zTweak, 
       0, 0,  6 * zTweak);  
         
  box(1000 * xTweak, 
      20 * 60 * yTweak, 
      12 * zTweak); 
      
}

//Plot the day and time of day on circle in the xz plane  
//plot the month/year on the y-axis
int[] yVals = {100, 500, 900, 1300, 1700, 2100, 2500, 2900, 3300};

int assignYswirl(int yr)
{
  switch(yr)
  {
    case 2006:
      return -300;
    case 2007:
      return -250;
    case 2008:
      return -200;
    case 2009:
      return -150;
    case 2010:
      return -100;
    case 2011:
      return -50;
    case 2012:
      return 0;
    case 2013:
      return 50;
    case 2014:
      return 100;
    default:
      return 150;
  }
}

void chooseRandomPoints()
{
  if(groupAppearance == MAX_GROUP)
    return;
  
    println("~~~~~~~~~~~~ 0");

  for(int i = 0; i < groupAppearance; i++)
  {
    if((int)random(0,2) == 0) //choose from cout
    {
      cout_pts.append((int) random(0.0, MAX_GROUP));
    }
    else //chose from cin
    {
      cin_pts.append((int) random(0.0, MAX_GROUP));
    }
  }
  
  cout_pts.sort();
  cin_pts.sort();
  
  //Find and Remove Duplicates for a Unique List
  int duplicate = 1;
  while(duplicate == 1)
  {
    duplicate = 0;
    
    for(int i = 0; i < cout_pts.size() - 1; i++)
    {
      if((Integer)cout_pts.get(i) == (Integer)cout_pts.get(i + 1))
      {
        duplicate = 1;
        cout_pts.remove(i + 1);
        cout_pts.append((int) random(0.0, MAX_GROUP));
      }
    }
    if(duplicate == 1)
      cout_pts.sort();
  }

  duplicate = 1;
  while(duplicate == 1)
  {
    duplicate = 0;
    
    for(int i = 0; i < cin_pts.size() - 1; i++)
    {
      if((Integer)cin_pts.get(i) == (Integer)cin_pts.get(i + 1))
      {
        duplicate = 1;
        cin_pts.remove(i + 1);
        cin_pts.append((int) random(0.0, MAX_GROUP));
      }
    }
    if(duplicate == 1)
      cin_pts.sort();
  }

}

void DrawPointSwirl()
{
  colorMode(RGB);
  stroke(255, 0, 0);
  strokeWeight(pointSize);
  
  //format: 1:month, 2:day, 3:year, 4:hour, 5:min
  float max_radius = 300; //radius will depend on min
  float angle  = TWO_PI / (24.0 * 59.0); //24 hrs in a day
    
  for(int i = 0; i < numRows; i++)
  {
    if(groupAppearance == MAX_GROUP || cout_pts.hasValue(i))
    {
      pointColor(i, 
                 daysInMonth[ ((whichYear(dataMatrix[i][3]) - 1) * 12) + (dataMatrix[i][1] - 1)],
                 colorThemeCout, 
                 dataMatrix[i][1], dataMatrix[i][2], dataMatrix[i][3], dataMatrix[i][4], dataMatrix[i][5]);
    
      point( (dataMatrix[i][5] * 7) * sin(angle * (dataMatrix[i][4] * dataMatrix[i][5])),  //x
             assignYswirl(dataMatrix[i][3]) + (dataMatrix[i][1] * 4),      //y
             (dataMatrix[i][5] * 7) * cos(angle * (dataMatrix[i][4] * dataMatrix[i][5]))); //z   
    }  
  }
  
  for(int i = 0; i < numRows; i++)
  {
    if(groupAppearance == MAX_GROUP || cin_pts.hasValue(i))
    {
      pointColor(i, 
                 daysInMonth[ ((whichYear(dataMatrix[i][8]) - 1) * 12) + (dataMatrix[i][6] - 1)],
                 colorThemeCin, dataMatrix[i][6], dataMatrix[i][7], 
                 dataMatrix[i][8], dataMatrix[i][9], dataMatrix[i][10]);
    
      point( (dataMatrix[i][10] * 4) * sin(angle * (dataMatrix[i][9] * dataMatrix[i][5])),  //x
             assignYswirl(dataMatrix[i][8]) + (dataMatrix[i][1] * 4),       //y
             (dataMatrix[i][10] * 4) * cos(angle * (dataMatrix[i][9] * dataMatrix[i][5]))); //z  
    }   
  }
  
  //Animation
 // groupAppearance = groupAppearance + counterGroup;
  
  if(counterGroup == MAX_GROUP)
    return;
  
  if(down == 1)
  {
    groupAppearance = groupAppearance - counterGroup;        
  }
  else if(down == 0)
  {
    groupAppearance = groupAppearance + counterGroup;
  }
  
  
  if(groupAppearance >= MAX_GROUP)
  {
    //groupAppearance = groupAppearance - counterGroup;
    groupAppearance = MAX_GROUP - 1;
    down = 1;
  }
  else if(groupAppearance == 0)
  {
    //groupAppearance = groupAppearance + counterGroup;
    down = 0;
  }

  chooseRandomPoints();
}

int assignY(int yr)
{
  switch(yr)
  {
    case 2006:
      return -300;
    case 2007:
      return -250;
    case 2008:
      return -200;
    case 2009:
      return -150;
    case 2010:
      return -100;
    case 2011:
      return -50;
    case 2012:
      return 0;
    case 2013:
      return 50;
    case 2014:
      return 100;
    default:
      return 150;
  }
}

void DrawPointStar()
{
  colorMode(RGB);
  stroke(255, 0, 0);
  strokeWeight(pointSize);
  
  //format: 1:month, 2:day, 3:year, 4:hour, 5:min
  float max_radius = 300; //radius will depend on min
  float angle  = TWO_PI / 24.0; //24 hrs in a day
  
  for(int i = 0; i < numRows; i++)
  {
    if(groupAppearance == MAX_GROUP || cout_pts.hasValue(i))
    {
      pointColor(i, 
                 daysInMonth[ ((whichYear(dataMatrix[i][3]) - 1) * 12) + (dataMatrix[i][1] - 1)],
                 colorThemeCout, dataMatrix[i][1], dataMatrix[i][2], dataMatrix[i][3], 
                 dataMatrix[i][4], dataMatrix[i][5]);

      point( (dataMatrix[i][5] * 7) * sin(angle * dataMatrix[i][4]),  //x
              assignY(dataMatrix[i][3]) + (dataMatrix[i][1] * 2),     //y
             (dataMatrix[i][5] * 7) * cos(angle * dataMatrix[i][4])); //z 
    }    
  }
  
  stroke(0, 0, 255);
  for(int i = 0; i < numRows; i++)
  {
    if(groupAppearance == MAX_GROUP || cout_pts.hasValue(i))
    {
      pointColor(i, 
                 daysInMonth[ ((whichYear(dataMatrix[i][8]) - 1) * 12) + (dataMatrix[i][6] - 1)],
                 colorThemeCin, dataMatrix[i][6], dataMatrix[i][7], dataMatrix[i][8], 
                 dataMatrix[i][9], dataMatrix[i][10]);

      point( (dataMatrix[i][10] * 4) * sin(angle * dataMatrix[i][9]),  //x
             assignY(dataMatrix[i][8]) + (dataMatrix[i][1] * 2),       //y
             (dataMatrix[i][10] * 4) * cos(angle * dataMatrix[i][9])); //z     
    }
  }
}

int whichYear(int yr)
{
  switch(yr)
  {
    case 2006:
      return 1;
    case 2007:
      return 2;
    case 2008:
      return 3;
    case 2009:
      return 4;
    case 2010:
      return 5;
    case 2011:
      return 6;
    case 2012:
      return 7;
    case 2013:
      return 8;
    case 2014:
      return 9;
    default:
      println(yr);
      return 0;
  }
}

//www.mkyong.com/java/java-time-elapsed-in-days-hours-minutes=seconds/
int dayDiff(String end, String start)
{
  SimpleDateFormat simpleDateFormat = new SimpleDateFormat("dd/M/yyyy hh:mm:ss");
  try 
  {
    Date date1 = simpleDateFormat.parse(start);
    Date date2 = simpleDateFormat.parse(end);
    
    long different = date2.getTime() - date1.getTime();
    long secondsInMilli = 1000;
    long minutesInMilli = secondsInMilli * 60;
    long hoursInMilli   = minutesInMilli * 60;
    long daysInMilli    = hoursInMilli   * 24;
    
    long elapsedDays = different / daysInMilli;
    return int(elapsedDays);
  }
  catch(ParseException e)
  {
    e.printStackTrace();
  }
  return 0;
}             

//checkout in outer
//checkin  in inner
//format: 1:month, 2:day, 3:year, 4:hour, 5:min
//        6        7      8       9       10



void SaveMovie()
{
  if(frameCount % 60 == 0)
    println("frame rate is: " + frameRate);
  
  saveFrame("animation/#####.tif");
}






