///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 3: 3D Spatial Interactive
// Setup Function
//   * Read in CSV File Data
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////

int numRows    = 10457;
int numColumns = 11;

ArrayList<String> titles    = new ArrayList<String>();
ArrayList<String> itemTypes = new ArrayList<String>();

void setup()
{
  size(1440, 900, OPENGL);
  noSmooth();
  frameRate(60);
  
  //Make the window resizable
  if(frame != null)
    frame.setResizable(true);
    
  //Set up Peasy Cam
  cam = new PeasyCam(this, 0, 0, 0, 800);
  cam.setMaximumDistance(5000);
  
  //Set up Control P5
  controlP5 = new ControlP5(this);
  g3 = (PGraphics3D) g;
  setupGUI();  
  
  //Store CSV File
  myTable = loadTable("birdsCout_43.478_1.272.csv", "header");

  //data format : title, itemtype, dewey, cout, cin
  //table format: dewey, month, day, year, hour, min, month, day, year, hour, min
  dataMatrix = new int[numRows][numColumns];
  
  //Read from CSV File
  for(int i = 0; i < myTable.getRowCount(); i++)
  {
    //Add to lists
    titles.add(myTable.getString(i, 0));
    itemTypes.add(myTable.getString(i, 1));

    //Add to Data Matrix: dewey number
    dataMatrix[i][0]   = myTable.getInt(i, 2);
    
    //and Parse Date Strings (format: year-month-day hour:min:sec)
    //cout - checkout date
    String   date      = myTable.getString(i, 3);
    String[] date_list = split(date, '-');
    String[] day       = split(date_list[2], ' ');
    
    dataMatrix[i][1]   = int(date_list[1]); //month
    dataMatrix[i][2]   = int(day[0]);       //day
    dataMatrix[i][3]   = int(date_list[0]); //year
    
    //parse the time
    date_list = null;
    date_list = split(day[1], ':');
    dataMatrix[i][4] = int(date_list[0]); //hour
    dataMatrix[i][5] = int(date_list[1]); //min
    
    //cin - checkin date
    date      = myTable.getString(i, 4);
    date_list = split(date, '-');
    day       = split(date_list[2], ' ');
    
    dataMatrix[i][6] = int(date_list[1]); //month
    dataMatrix[i][7] = int(day[0]);       //day
    dataMatrix[i][8] = int(date_list[0]); //year
    
    //parse the time
    date_list = null;
    date_list = split(day[1], ':');
    dataMatrix[i][9]  = int(date_list[0]); //hour
    dataMatrix[i][10] = int(date_list[1]); //min    
  }
  
  cout_pts = new IntList();
  cin_pts  = new IntList();
}














